import {
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  transition,
} from 'd3';
export const scatterPlot = () => {
  let width;
  let height;
  let data;
  let xValue;
  let yValue;
  let margin;
  let radius;
  const my = (selection) => {
    //console.log(data);
    // scaleLinear does a mapping from data to screen

    //         const x = scaleLinear().domain([
    //           d3.min(data, xValue),
    //           d3.max(data, xValue),]
    //           // d3.min(+data.petal_length),
    //           // d3.max(+data.sepal_length),

    //         );
    const x = scaleLinear()
      .domain(extent(data, xValue))
      //.range([0, width]);
      .range([margin.left, width - margin.right]);
    const y = scaleLinear()
      .domain(extent(data, yValue))
      //.range([height, 0]);
      .range([
        height - margin.bottom,
        margin.top,
      ]);

    //console.log(x.range());

    const marks = data.map((d) => ({
      x: x(xValue(d)),
      y: y(yValue(d)),
      // p_x: xValue(d),
      // p_y: yValue(d),
    }));
    console.log(marks);

    const t = transition().duration(1000);

    const circle = selection
      .selectAll('circle')
      .data(marks)
      .join(
        (enter) =>
          enter
            .append('circle')
            .attr('cx', (d) => d.x)
            .attr('cy', (d) => d.y)
            .attr('r', 0)
            .call((enter) =>
              enter
                .transition(t)
                .attr('r', radius)
            ),
        (update) =>
          update.call((update) =>
            update
              .transition(t)
              .delay((d, i) => i * 20)
              .attr('cx', (d) => d.x)
              .attr('cy', (d) => d.y)
          ),
        (exit) => exit.remove()
      );
    // (enter) =>
    //   enter
    //     .append('text')
    //     .attr('fill', 'green')
    //     .attr('x', (d, i) => i * 16)
    //     .attr('y', -30)
    //     .text((d) => d)
    // .call(enter => enter.transition(t)).attr("y",0)),
    //   update => update.attr("fill","black").attr("y",0).call(update => update.transition(t)).attr("x",(d,i) => i* 16)),
    //     exit => exit.attr("fill","brown").call(exit => exit.transition(t)).attr("y",30).remove())

    //       .join('circle')
    //     //  .transition()
    // .attr('cx', (d) => d.x)
    // .attr('cy', (d) => d.y)

    //     // .append('title')
    //     // .text((d) => `(${d.p_x},${d.p_y})`);

    selection
      .selectAll('g.y-axis')
      .data([null])
      .join('g')
      .transition(t)
      .attr('class', 'y-axis')
      .attr(
        'transform',
        `translate(${margin.left},0)`
      )
      .call(axisLeft(y));
    selection
      .selectAll('g.x-axis')
      .data([null])
      .join('g')
      .transition(t)
      .attr('class', 'x-axis')
      .attr(
        'transform',
        `translate(0, ${height - margin.bottom})`
      )
      .call(axisBottom(x));
  };

  my.width = function (_) {
    return arguments.length
      ? ((width = +_), my) //return my
      : width;
  };
  my.height = function (_) {
    return arguments.length
      ? ((height = +_), my) //return my
      : height;
  };

  my.data = function (_) {
    return arguments.length
      ? ((data = _), my) //return my
      : data;
  };
  my.xValue = function (_) {
    return arguments.length
      ? ((xValue = _), my) //return my
      : xValue;
  };
  my.yValue = function (_) {
    return arguments.length
      ? ((yValue = _), my) //return my
      : yValue;
  };
  my.margin = function (_) {
    return arguments.length
      ? ((margin = _), my) //return my
      : margin;
  };
  my.radius = function (_) {
    return arguments.length
      ? ((radius = +_), my) //return my  "+" to make sure it is a number type
      : radius;
  };
  return my;
};
